/* Program2_1
 * A FRDM-KL25Z krtyra ptett zld LED (PTB19) villogtatsa. 
 * A regiszterek elrshez magunk definilunk szimbolikus neveket.  
 *
 * A program forrsa: Mazidi et al., Freescale ARM Cortex-M Embedded Programming
 * http://www.microdigitaled.com/ARM/Freescale_ARM/Code/Ver1/Chapter2/Program2_1.txt
 */
#define SIM_SCGC5   (*((volatile unsigned int*)0x40048038))
#define PORTB_PCR19 (*((volatile unsigned int*)0x4004A04C))
#define GPIOB_PDDR  (*((volatile unsigned int*)0x400FF054))
#define GPIOB_PDOR  (*((volatile unsigned int*)0x400FF040))

int main (void) {
    void delayMs(int n);            // Elore deklarljuk a delayMs() fggvnyt 
    SIM_SCGC5 |= 0x400;             // Port B rajelnek engedlyezse (bit10=1) 
    PORTB_PCR19 = 0x100;            // PTB19 pin legyen GPIO (MUX = 1, Alt1 mode)
    GPIOB_PDDR |= 0x80000;          // PTB19 legyen kimenet (bit 19 = 1)   
    while (1) {                     // Vgtelen ciklus...
        GPIOB_PDOR &= ~0x80000;     // Zld LED felkapcsolsa (bit19 = 0)
        delayMs(500);               // 500 ms vrakozs
        GPIOB_PDOR |= 0x80000;      // Zld LED lekapcsolsa   (bit19 = 1)
        delayMs(500);               // 500 ms vrakozs
    }
}
void delayMs(int n) {               // Kslelteto fggvny
    int i, j;
    for(i = 0 ; i < n; i++)
        for (j = 0; j < 3500; j++); // Alaprtelmezett rajelhez (20.97152 MHz)
}
