/* Program2_5
 * A FRDM-KL25Z krtyra ptett zld LED (PTB19) villogtatsa. 
 * A kimenet vezrlshez most hasznljuk a PSOR, PCOR, PTOR 
 * bitmanipulcis regisztereket!
 *
 * A program forrsa: Mazidi et al., Freescale ARM Cortex-M Embedded Programming
 * http://www.microdigitaled.com/ARM/Freescale_ARM/Code/Ver1/Chapter2/Program2_5.txt
 */


#include <MKL25Z4.h>  

int main (void) {
    void delayMs(int n);            // Elore deklarljuk a delayMs() fggvnyt 
    SIM->SCGC5 |= 0x400;            // Port B rajelnek engedlyezse (bit10=1) 
    PORTB->PCR[19] = 0x100;         // PTB19 pin legyen GPIO (MUX = 1, Alt1 mode)
    PTB->PDDR |= 0x80000;           // PTB19 legyen kimenet (bit 19 = 1)   
    while (1) {                     // Vgtelen ciklus...
		//--- 1. vltozat: PCOR s PSOR (bit clear/bit set) hasznlata
				PTB->PCOR = 0x80000;        // Zld LED felkapcsolsa (bit19 = 0)
        delayMs(500);               // 500 ms vrakozs
        PTB->PSOR = 0x80000;        // Zld LED lekapcsolsa   (bit19 = 1)
        delayMs(500);               // 500 ms vrakozs
		//--- 2. vltozat: PTOR (bit toggle) hasznlata
 		//	  PTB->PTOR = 0x80000;
		//	  delayMs(500); 
    }
}

void delayMs(int n) {               // Kslelteto fggvny
    int i, j;
    for(i = 0 ; i < n; i++)
        for (j = 0; j < 3500; j++); // Alaprtelmezett rajelhez (20.97152 MHz)
}
