/* Program2_7
 * A FRDM-KL25Z krtyra ptett RGB LED alapszn kombinciinak krbelptetse.  
 *
 * A program forrsa: Mazidi et al., Freescale ARM Cortex-M Embedded Programming
 * http://www.microdigitaled.com/ARM/Freescale_ARM/Code/Ver1/Chapter2/Program2_7.txt
 */

#include <MKL25Z4.h>   

int main (void) {
  void delayMs(int n);
  int counter = 0;    
  SIM->SCGC5 |= 0x1400;         // Port B s D engedlyezse (bit 10 s bit 12)
  PORTB->PCR[18] = 0x100;       // PTB18 legyen GPIO (MUX = 1)
  PORTB->PCR[19] = 0x100;       // PTB19 legyen GPIO (MUX = 1)
  PORTD->PCR[1]  = 0x100;       // PTD1 legyen GPIO  (MUX = 1)
  PTB->PDDR |= 0xC0000;         // PTB18 s PTB19 legyen kimenet (bit18 s 19=1)
  PTD->PDDR |= 0x02;            // PTD1 legyen kimenet (bit1 = 1)
  while (1) {
    if (counter & 1) PTB->PCOR = 0x40000; // Piros LED: BE (bit18 = 0)
      else PTB->PSOR = 0x40000; // Piros LED: KI           (bit18 = 1)    
    if (counter & 2) PTB->PCOR = 0x80000; // Zld LED: BE  (bit19 = 0)
      else PTB->PSOR = 0x80000; // Zld LED: KI            (bit19 = 1)
    if (counter & 4) PTD->PCOR = 0x02;    // Kk LED: BE   (bit1  = 0)
      else PTD->PSOR = 0x02;    // Kk LED: KI             (bit1  = 0)
    counter++;
    delayMs(500);
  }
}

void delayMs(int n) {               // Kslelteto fggvny
    int i, j;
    for(i = 0 ; i < n; i++)
        for (j = 0; j < 3500; j++); // Alaprtelmezett rajelhez (20.97152 MHz)
}
