/* Program2_8
 *
 * LED vezrlse nyomgombbal. Ha a PTA12 bemenet s a GND 
 * kz kttt nyomgombot lenyomjuk, a zld LED vilgtani kezd. 
 * Ha a nyomgombot felengedjk, a LED kialszik.
 * A PTA12 bemenet felhzshoz bekapcsoljuk a belso felhzst. 
 *
 * A program forrsa: Mazidi et al., Freescale ARM Cortex-M Embedded Programming
 * http://www.microdigitaled.com/ARM/Freescale_ARM/Code/Ver1/Chapter2/Program2_8.txt
 */

#include <MKL25Z4.h>   

int main (void) {
    SIM->SCGC5 |= 0x600;         // A s B port engedlyezse
    PORTB->PCR[19] = 0x100;      // PTB19 legyen GPIO (MUX = 1)
    PTB->PDDR |= 0x80000;        // PTB19 legyen kimenet (Zld LED vezrls)
    
    SIM->SCGC5 |= 0x200;         // A port engedlyezse
    PORTA->PCR[12] = 0x103;      // PTA12: GPIO, felhzssal (PE=1,PS=1, MUX=1)
    PTA->PDDR &= ~0x1000;        // PTA12 legyen bemenet (PDDR bit 12 = 0)
     
    while (1) {
        if (PTA->PDIR & 0x1000)  // Gomblenyoms figyelse
            PTB->PSOR = 0x80000; // Felengedve: LED KI
        else
            PTB->PCOR = 0x80000; // Lenyomva: LED be
    }
}

