/* Program2_9
 *
 * LED kijelz vezrlse: 25-t ratunk ki egy 2-jegy 7-szegmenses LED kijelzn.
 *
 * Kt kzs katd 7-szegmenses LED kijelzt hasznlunk (vagy  1 db ktszmjegyt...).
 * A PTD0...PTD6 kivezetseket rendre az A...G szegmensekre ktjk.
 * PTE0 vezrli a jobboldali szmjegyet (alacsony szint lehzza a kzs katdot).
 * PTE1 vezrli a baloldali szmjegyet (alacsony szint lehzza a kzs katdot)
 * Figyelem! Legalbb a PTE0, PTE1 lbakon hasznljunk egy-egy ramkorltoz 
 * ellenllst (100 - 470 Ohm)! Ennek hinyban a mikrovezrl krosodhat!
 *
 * A PTD0...PTD6 kivezetseket az alaprtelmezett kisram mdba konfigurljuk,
 * a PTE0, PTE1 kivezetseket pedig nagyram kimenentknt konfigurljuk (DSE=1).
 *
 * Ez az sszellts csak kiprblsra ajnlott. Komolyabb hasznlathoz a 
 * katdokat egy-egy tranzisztorral hzzuk le, s a szegmenseket vezrl 
 * vonalakat is lltsuk nagyobb ram mdba, s szegmensvezrl kimenetenknt 
 * ramkorltozst!
 * 
 * A program forrsa: Mazidi et al., Freescale ARM Cortex-M Embedded Programming
 * http://www.microdigitaled.com/ARM/Freescale_ARM/Code/Ver1/Chapter2/Program2_9.txt
 */

#include <MKL25Z4.H>

void delayMs(int n);

int main(void)
{    
    unsigned char digitPattern[] = 
        {0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F};
        /*from Table 2-7 */

    SIM->SCGC5 |= 0x1000;       // D port engedlyezse
    SIM->SCGC5 |= 0x2000;       // E port engedlyezse
    PORTD->PCR[0] = 0x100;      // PTD0 legyen GPIO kivezets
    PORTD->PCR[1] = 0x100;      // PTD1 legyen GPIO kivezets
    PORTD->PCR[2] = 0x100;      // PTD2 legyen GPIO kivezets
    PORTD->PCR[3] = 0x100;      // PTD3 legyen GPIO kivezets
    PORTD->PCR[4] = 0x100;      // PTD4 legyen GPIO kivezets
    PORTD->PCR[5] = 0x100;      // PTD5 legyen GPIO kivezets
    PORTD->PCR[6] = 0x100;      // PTD6 legyen GPIO kivezets
    PTD->PDDR |= 0x7F;          // PTD0...PTD6 legyen kimenet
    PORTE->PCR[0] = 0x144;      // PTE0 legyen GPIO, strong out, SRE=low
    PORTE->PCR[1] = 0x144;      // PTE1 legyen GPIO, strong out, SRE=low
    PTE->PDDR |= 0x03;          // PTE1 s PTE0 legyen kimenet

    for(;;)
    {
        PTD->PDOR = digitPattern[2];    // A 2-es szmjegy bitmintja kerljn a kimenetre
        PTE->PSOR = 0x01;               // A jobboldali szmjegy tiltsa
        PTE->PCOR = 0x02;               // A baloldali szmjegy bekapcsolsa
        /* 8 ms ksleltets alkalmazsa 16 ms frisstsi ciklust eredmnyez, ami 62.5 Hz */
        delayMs(8);

        PTD->PDOR = digitPattern[5];    // Az 5-s szmjegy bitmintja kerljn a kimenetre
        PTE->PCOR = 0x01;               // A jobboldali szmjegy bekapcsolsa
        PTE->PSOR = 0x02;               // A baloldali szmjegy letiltsa
        delayMs(8);       
    }
}

/* Ksleltet fggvny: Vrakozs n milliszekundumig
 * A CPU rendszerrajel alaprtelmezett rtke 20.97152 MHz
 */
void delayMs(int n) {
    int i;
    int j;
    for(i = 0 ; i < n; i++)
        for (j = 0; j < 3500; j++) {}
}
